% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}
\usepackage{../../../../grammar}
\usepackage{graphicx}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Five.III\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}



\begin{questions}
\question
For each, give the characterization that best applies:~a function problem, 
a decision problem, a language decision problem, a search
problem, or an optimization problem.
\begin{parts}
\part The \probname{$3$-Satisfiability} problem,\index{3-Satisfiability problem@$3$-\probname{Satisfiability} problem}
\begin{solution}
Decision problem
\end{solution}

\part The \probname{Divisor} problem
\begin{solution}
Search problem
\end{solution}

\part The \probname{Prime Factorization} problem
\begin{solution}
Function problem
\end{solution}

\part The \prob[F\!-\!S\kern-1.25ptAT] problem, 
  where the input is a propositional logic
  expression and the output is either an assignment of \true{} and~\false{}
  to the expression's variables that makes it evaluate to~\true{},
  or the string \str{None}.
\begin{solution}
Function problem  
\end{solution}
\part The \probname{Composite} problem
\begin{solution}
Decision problem
\end{solution}
\end{parts}

\question
Express as a language decision problem.
Describe the string
representation.
\begin{parts}
\part Decide whether a number is a perfect square.
\begin{solution}
A language suited to Turing machines is  
$\lang_0=\set{\str{1}^n\suchthat \text{$n\in\N$ is a square}}$.
A language suited to more everyday machines is
$\lang_1=\set{d\in\kleenestar{\set{\str{0},\ldots{}\str{9}}}\suchthat
              \text{$d$ represents a perfect square in base~$10$}}$. 
\end{solution}
\part Decide whether a triple $\sequence{x,y,z}\in\N^3$ is a 
   Pythagorean triple, that is, whether $x^2+y^2=z^2$.
\begin{solution}
One language is the set of triples
$\sequence{x,y,z}\in\kleenestar{\set{\str{0},\ldots~\str{9}}}$
such that $x,y,z$ represent integers in base~$10$ where 
the squares of the first two add to the square of the third.   
\end{solution}

\part Decide whether a graph has an even number of edges.
\begin{solution}
A language is 
$\set{\sigma\in\kleenestar{\B}\suchthat \text{$\sigma$ represents a graph $\mathcal{G}$ with an even number of edges}}$.
\end{solution}

\part Decide whether a path in a graph has any repeated vertices.
\begin{solution}
The language 
$\set{\sigma\in\kleenestar{\B}\suchthat \text{$\sigma$ represents a pair $\sequence{\mathcal{G},p}$ where $p$ is a path with a repeated vertex}}$
will do.
\end{solution}
\end{parts}


\question
Recast each in language decision terms. 
Include explicit mention of the string
representation.
\begin{parts}
\part
\probname{Graph Colorability}
\begin{solution}
The \probname{Graph Colorability} problem is stated as a decision problem.
Imagine that we had an algorithm 
to recognize membership in this language.
\begin{equation*}
  \lang=\set{\sigma\in\kleenestar{\B}\suchthat \text{$\sigma$ represents 
      $\sequence{\mathcal{G},k}$, where $\mathcal{G}$ is $k$-colorable}}
\end{equation*}
Then, given an graph and an integer~$k$, we 
could use that algorithm to decide whether the graph is $k$-colorable.
Convert the graph and integer to a string representing 
the pair, and use the algorithm to decide if that pair is in the language.
\end{solution}

\part
\probname{Euler Circuit}
\begin{solution}
Consider this.
\begin{equation*}
  \lang=\set{\sigma\in\kleenestar{\B}\suchthat \text{$\sigma$ represents a graph with a path that traverses each edge exactly once}}
\end{equation*}
The \probname{Euler Circuit} problem is given as a function problem.
If we had an algorithm 
to recognize membership in the language then, given an graph, we 
could use that algorithm to decide whether the graph has a circuit:
we just convert the graph to its representation and apply the algorithm.
If we know there is no Euler circuit then we are done.
If we know there is an Euler circuit then a search will find it.
\end{solution}

% \part
% \probname{Shortest Path}
% \begin{solution}
% The \probname{Shortest Path} problem is given as a function problem.
% If we had an algorithm 
% to recognize membership in the language
% \begin{equation*}
%   \lang=\set{\sigma\in\kleenestar{\B}\suchthat \text{$\sigma$ represents 
%       $\sequence{\mathcal{G},v_0,v_1,p}$, where $p$ is a minimal-length path between the vertices}}
% \end{equation*}
% then, given an graph and two vertices, we 
% could find the minimal path by using that algorithm to test 
% all possible paths from one vertex 
% to the other for minimality by seeing if the representation of the 
% quad is in the language.  
% \end{solution}
\end{parts}


\question
As stated, the \probname{Shortest Path}
problem
is an optimization problem.
Convert it into a parametrized family of language decision problems.
\begin{solution}
Take $B\in\N$ as a bound and consider this family.
\begin{equation*}
  \lang_{B}=\set{\sequence{\mathcal{G},v_0,v_1}\suchthat\text{There is a path from $v_0$ to $v_1$ of distance less than or equal to~$B$}}
\end{equation*}
Given a graph and two vertices we can solve the \probname{Shortest Path} 
problem for it
by searching through $\lang_1$, $\lang_2$, \ldots until we find the 
smallest bound~$B$ for which our triple is 
a member of the language~$\lang_{B}$. 
\end{solution}

\end{questions}
\end{document}
